> For the complete documentation index, see [llms.txt](https://docs.lithnet.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lithnet.io/ecma2-framework/advanced/index/lithnet.ecma2framework.iobjectpasswordprovider.md).

# IObjectPasswordProvider

Namespace: Lithnet.Ecma2Framework

Defines the methods and properties that a password provider must implement

```csharp
public interface IObjectPasswordProvider
```

## Methods

### **InitializeAsync(PasswordContext)**

Initializes the password provider. This method is called once at the start of a batch of password operations

```csharp
Task InitializeAsync(PasswordContext context)
```

#### Parameters

`context` [PasswordContext](/ecma2-framework/advanced/index/lithnet.ecma2framework.passwordcontext.md)\
The context of the operation

#### Returns

[Task](https://docs.microsoft.com/en-us/dotnet/api/system.threading.tasks.task)\
A task that represents the asynchronous operation

### **CanPerformPasswordOperationAsync(CSEntry)**

Indicates whether the password provider can perform password operations on the specified object

```csharp
Task<bool> CanPerformPasswordOperationAsync(CSEntry csentry)
```

#### Parameters

`csentry` CSEntry\
The CSEntry representing the object with the associated password change

#### Returns

[Task\<Boolean>](https://docs.microsoft.com/en-us/dotnet/api/system.threading.tasks.task-1)\
if the provider can process the password change, otherwise

### **SetPasswordAsync(CSEntry, SecureString, PasswordOptions)**

Sets the password on the specified object

```csharp
Task SetPasswordAsync(CSEntry csentry, SecureString newPassword, PasswordOptions options)
```

#### Parameters

`csentry` CSEntry\
The CSEntry representing the object whose password should be set

`newPassword` [SecureString](https://docs.microsoft.com/en-us/dotnet/api/system.security.securestring)\
The new password

`options` PasswordOptions\
Flags that indicate additional steps that may need to be taken once the password it set

#### Returns

[Task](https://docs.microsoft.com/en-us/dotnet/api/system.threading.tasks.task)\
A task that represents the asynchronous operation

### **ChangePasswordAsync(CSEntry, SecureString, SecureString)**

Changes the password on the specified object

```csharp
Task ChangePasswordAsync(CSEntry csentry, SecureString oldPassword, SecureString newPassword)
```

#### Parameters

`csentry` CSEntry\
The CSEntry representing the object whose password should be changed

`oldPassword` [SecureString](https://docs.microsoft.com/en-us/dotnet/api/system.security.securestring)\
The old password

`newPassword` [SecureString](https://docs.microsoft.com/en-us/dotnet/api/system.security.securestring)\
The new password

#### Returns

[Task](https://docs.microsoft.com/en-us/dotnet/api/system.threading.tasks.task)\
A task that represents the asynchronous operation


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.lithnet.io/ecma2-framework/advanced/index/lithnet.ecma2framework.iobjectpasswordprovider.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
